VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHTTP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Public WithEvents PrimarySocket As clsSocket
Attribute PrimarySocket.VB_VarHelpID = -1

' Internal variables
Private Clients() As clsConnection
Private ClientCount As Long
Private m_SafeChar(255) As Boolean

Public Sub StartServer(Port As Long)

    Set PrimarySocket = New clsSocket
    
    PrimarySocket.LocalPort = Port
    PrimarySocket.Listen
    
End Sub

Public Sub StopServer()
    
    ' Close the primary socket
    If Not (PrimarySocket Is Nothing) Then
        PrimarySocket.CloseSocket
        Set PrimarySocket = Nothing
    End If
    
    ClientCount = 0
    Erase Clients

End Sub

Private Sub Class_Initialize()

    SetSafeChars

End Sub

Private Sub Class_Terminate()

    StopServer

End Sub

Private Sub PrimarySocket_OnConnectionRequest(ByVal requestID As Long)

    Dim Tell As Long

    For Tell = 0 To ClientCount - 1
        If Clients(Tell) Is Nothing Then
            Exit For
        Else
        
            If Clients(Tell).Socket.State = sckClosed Then
                Exit For
            End If
        
        End If
    Next
    
    If Tell > ClientCount - 1 Then
    
        ReDim Preserve Clients(ClientCount)
        
        ' This is the current index now
        Tell = ClientCount
        
        ' Increse the variable holding client-information
        ClientCount = ClientCount + 1
    
    End If

    Set Clients(Tell) = New clsConnection
    Set Clients(Tell).Socket = New clsSocket
    Set Clients(Tell).Trapper = Me
    
    Clients(Tell).Index = Tell
    Clients(Tell).Socket.CloseSocket
    Clients(Tell).Socket.Accept requestID

End Sub

Public Sub SocketEvent(Index As Long, EventType As String, ParamArray Paramenters() As Variant)

    Dim sBuffer As String, Free As Long, sConnection As String

    Select Case EventType
    Case "OnClose"
    
        ' Free all resources
        Set Clients(Index) = Nothing
    
    Case "OnSendComplete"
    
        ' Retrive the current connection-state
        sConnection = LCase(Clients(Index).ResponseMIME.MimeValue("Connection"))
    
        If Clients(Index).URL <> "" Then
    
            Free = FreeFile
    
            Open Clients(Index).URL For Binary As #Free
        
                If Clients(Index).FileIndex < LOF(Free) Then
        
                    If Clients(Index).FileIndex < 1 Then
                        Clients(Index).FileIndex = 1
                    End If
    
                    sBuffer = Space(1024)
                    Get #Free, Clients(Index).FileIndex, sBuffer
            
                    Clients(Index).Socket.SendData sBuffer
                    Clients(Index).FileIndex = Clients(Index).FileIndex + 1024
        
                    ' Log this transfer
                    Statistic.IncreseVariable "BytesSend", 1024
        
                Else
                
                    Clients(Index).URL = ""
                    
                    If sConnection = "close" Then
                        Clients(Index).Socket.CloseSocket
                    End If
                
                End If
        
            Close #Free
            
        Else
        
            If sConnection = "close" Then
                Clients(Index).Socket.CloseSocket
            End If
        
        End If
    
    Case "OnDataArrival"
    
        Clients(Index).Socket.GetData sBuffer
        Clients(Index).Buffer = Clients(Index).Buffer & sBuffer
        
        ' End of request
        If Right(Clients(Index).Buffer, 4) = vbCrLf & vbCrLf Then
        
            ' Process the request
            ProcessRequest Clients(Index).Buffer, Clients(Index)
        
            ' Deallocate the buffer
            Clients(Index).Buffer = ""
        
        End If
    
    End Select

End Sub

Private Sub ProcessRequest(sText As String, Connection As clsConnection)

    On Error Resume Next
    Dim aLines, aRequest, aTemp, Tell As Long, sResponse As String
    
    aLines = Split(sText, vbCrLf)
    aRequest = Split(aLines(0), " ")
    
    ' All requests must be logged
    Log.AddString Now & ": " & Connection.Socket.RemoteHostIP & "@" & ":" & Connection.Socket.RemotePort & "  " & aLines(0)
    
    Select Case UCase(aRequest(0)) ' Request command
    Case "GET"
    
        ' Clear MIME
        Set Connection.RequestMIME = New clsMIME
        Set Connection.ResponseMIME = New clsMIME
        
        ' Default reponse MIME:
        Connection.ResponseMIME.Add "Server", "HTTPServer 1.0"
        Connection.ResponseMIME.Add "Connection", "Keep-Alive"
    
        'If Settings.VariableValue("ContentRange") = 0 Then
            Connection.ResponseMIME.Add "Accept-Ranges", "none"
        'Else
        '    Connection.ResponseMIME.Add "Accept-Ranges", "byte" ' TO-DO: Add support for "byte"
        'End If

        ' Add all MIME's (We're not so concerned about this yet)
        For Tell = 1 To UBound(aLines)
        
            aTemp = Split(aLines(Tell), ": ")
            
            If UBound(aTemp) > 0 Then
                Connection.RequestMIME.Add CStr(aTemp(0)), CStr(aTemp(1))
            End If
            
        Next
        
        ' The default response
        Connection.Response = aRequest(2) & " 200 OK"
        
        ' When the client ask to close the connection, do so
        If LCase(Connection.RequestMIME.MimeName("Connection")) = "close" Then
            Connection.ResponseMIME.MimeValue("Connection") = "Close"
        End If
        
        ' The URL-request will always begin with "/", so we can't have a "\" at the end of the index path
        If Right(Settings.VariableValue("IndexPath"), 1) = "\" Then
            Settings.VariableValue("IndexPath") = CutTo(Settings.VariableValue("IndexPath"), "\", , 1)
        End If
        
        Connection.URL = Settings.VariableValue("IndexPath") & URLDecode(Replace(aRequest(1), "/", "\"))
        Connection.OriginalRequest = aRequest(1)
        
        ' If we don't have a file, use default:
        If Right(Connection.URL, 1) = "\" Then
            
            aTemp = Settings.VariableValue("IndexNames")
            
            For Tell = LBound(aTemp) To UBound(aTemp)
                If Dir(Connection.URL & aTemp(Tell)) <> "" Then
                    Connection.URL = Connection.URL & aTemp(Tell)
                    Exit For
                End If
            Next
            
            ' Directory listing
            If Tell > UBound(aTemp) Then
                If Settings.VariableValue("DLEnable", True) = True Then
                
                    ' Each directory listing should be logged
                    Statistic.IncreseVariable "RequestsDirectoryListing", 1
                
                    ' Generate the HTML from the requested folder
                    sResponse = GenerateDirectoryHTML(Connection, CutTo(Connection.URL, "\"))
                
                    ' Add MIME
                    Connection.ResponseMIME.Add "Content-Type", "text/html"
                    Connection.ResponseMIME.Add "Content-Lenght", Len(sResponse)
                    
                    Connection.URL = ""
                    
                    ' Send header and information
                    SendHeader Connection, Connection.Response, sResponse
                    Exit Sub
                    
                End If
            End If
                        
        End If
        
        If Dir(Connection.URL) <> "" Then
        
            ' Log this attempt
            Statistic.IncreseVariable "RequestsOK", 1
        
            ' Add important MIME information
            Connection.ResponseMIME.Add "Content-Lenght", FileLen(Connection.URL)
            Connection.ResponseMIME.Add "Content-Type", ContentType(GetExtention(Connection.URL))
        
            ' Send response
            Connection.FileIndex = 1
            SendHeader Connection, Connection.Response, ""

        Else ' File not found
            
            ' Log this failed attempt
            Statistic.IncreseVariable "RequestsFileNotFound", 1
        
            ' Send the error message
            SendHeader Connection, aRequest(2) & " 404 Not Found", "<html><h1>404 - File not found</h1></html>"
            
        End If
    
    Case Else
    
            ' Send the error message and log it
            Statistic.IncreseVariable "RequestsMethodNotAllowed", 1
            SendHeader Connection, aRequest(2) & " 405 Method Not Allowed", "<html><h1>405 - Method Not Allowed</h1></html>"
    
    End Select

End Sub

Public Function SendHeader(Connection As clsConnection, sResponse As String, sMessage As String)

    Dim sMIME As String
    
    ' Retrive the MIME
    sMIME = Connection.ResponseMIME.ToString

    Connection.ResponseMIME.MimeValue("Content-Lenght") = Connection.ResponseMIME("Content-Lenght") + Len(sMIME) + Len(sResponse) + 3
    Connection.Socket.SendData sResponse & vbCrLf & sMIME & vbCrLf & vbCrLf & sMessage
    
End Function

Public Function GenerateDirectoryHTML(Connection As clsConnection, sPath As String) As String

    On Error Resume Next
    Dim sFile As String, sResult As String, parentFolder As String
    Dim parentTime As Date, bDate As Boolean, bSize As Boolean
    
    bDate = CBool(Settings.VariableValue("DLShowDate") = 1)
    bSize = CBool(Settings.VariableValue("DLShowSize") = 1)
    
    parentFolder = CutTo(Connection.OriginalRequest, "/")
    parentFolder = CutTo(parentFolder, "/", Len(parentFolder) - 1)
    parentTime = FileDateTime(CutTo(sPath, "\", Len(sPath) - 1, 1))
    
    sResult = "<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 3.2 Final//EN"">" & vbCrLf & _
              "<html>" & vbCrLf & _
              "<head>" & vbCrLf & _
              "<title>Index of " & Connection.OriginalRequest & "</title>" & vbCrLf & _
              "</head>" & vbCrLf & _
              "<body>" & vbCrLf & _
              "<h1>Index of " & Connection.OriginalRequest & "</h1>" & vbCrLf & _
              "<pre>" & Space(6) & "<strong>Name</strong>" & Space(35)
              
    If bDate Then sResult = sResult & "<strong>Last modified</strong>" & Space(9)
    If bSize Then sResult = sResult & "<strong>Size</strong>" & vbCrLf
    
    sResult = sResult & "<hr>[DIR] <a href=" & Chr(34) & URLEncode(parentFolder) & Chr(34) & ">Parent Directory</a>" & Space(23) & IIf(bDate, parentTime, "") & Space(3) & "- " & vbCrLf
    sFile = Dir(sPath, vbDirectory Or vbNormal Or IIf(Settings.VariableValue("DLShowHiddenFiles") = 1, vbHidden, 0))
    
    Do Until sFile = ""
    
        If Not (sFile = "." Or sFile = "..") Then
            sResult = sResult & Space(6) & "<a href=" & URLEncode(sFile) & IIf((GetAttr(sPath & sFile) And vbDirectory) = vbDirectory, "/", "") & ">" & LimitSize(sFile, 37) & "</a> " & Space(38 - Len(LimitSize(sFile, 37))) & IIf(bDate, FileDateTime(sPath & sFile) & Space(3), "") & IIf(bSize, FileLen(sPath & sFile), "") & vbCrLf
        End If
        
        sFile = Dir
    Loop
    
    ' Return result
    GenerateDirectoryHTML = sResult & "</pre><hr>" & vbCrLf & _
                                      "<address>HTTPServer at " & PrimarySocket.LocalHostName & " Port " & PrimarySocket.LocalPort & "</address>" & vbCrLf & _
                                      "</body></html>"

End Function

Public Function ContentType(Extension As String) As String

    Select Case LCase(Extension)
        Case "gif", "ief", "rgb", "cgm", "fif": ContentType = "image/" & Extension
        Case "png", "cmx", "pict": ContentType = "image/x-" & Extension
        Case "jpg", "jpeg", "jpe": ContentType = "image/jpeg"
        Case "tiff", "tif": ContentType = "image/tiff"
        Case "xbm": ContentType = "image/x-xbitmap"
        Case "xpm": ContentType = "image/x-xpixmap"
        Case "g3f": ContentType = "image/g3fax"
        Case "rtf", "pdf", "zip", "exe": ContentType = "application/" & Extension
        Case "ai", "eps", "ps": ContentType = "application/postscript"
        Case "mpeg", "mpg", "mpe": ContentType = "movie/mpeg"
        Case "ql", "mov": ContentType = "video/quicktime"
        Case "avi": ContentType = "video/x-msvideo"
        Case "movie": ContentType = "video/x-sgi-movie"
        Case "css": ContentType = "text/css"
        Case "html", "htm": ContentType = "text/html"
        Case Else
        
            ContentType = GetContentType("." & LCase(Extension))
        
    End Select

End Function

Private Function GetContentType(ByVal s As String) As String

    Dim hKey As Long, lpSubKey As String, lpValueName As String
    Dim lpType As Long, lpData As String, lpcbData As Long
    
    GetContentType = "application/octet-stream"
    
    lpSubKey = "Content Type"
    
    If RegOpenKeyEx(HKEY_CLASSES_ROOT, s, 0, KEY_QUERY_VALUE, hKey) = ERROR_SUCCESS Then
      
        RegQueryValueEx hKey, lpSubKey, 0, lpType, Chr(0), lpcbData
        
        If lpType = REG_SZ Then
          
            lpData = Space(lpcbData)
            
            If RegQueryValueEx(hKey, lpSubKey, 0, lpType, ByVal lpData, lpcbData) = ERROR_SUCCESS Then
                GetContentType = Left(lpData, lpcbData)
            End If
          
        End If
        
        RegCloseKey hKey
      
    End If
  
End Function

Public Function URLDecode(URL As String) As String

    Dim sTemp As String, Tell As Long, Char As Long, LastChar As Long

    LastChar = 1
    Char = InStr(1, URL, "%")

    Do Until Char = 0
        sTemp = sTemp & Mid(URL, LastChar, Char - 1) & Chr(Val("&H" & Mid(URL, Char + 1, 2)))
        LastChar = Char + 3
        Char = InStr(Char + 1, URL, "%")
    Loop

    URLDecode = Replace(sTemp & Mid(URL, LastChar, Len(URL) - Char), "+", " ")
    
End Function

Public Function URLEncode(ByVal txt As String) As String

    Dim i As Integer
    Dim ch As String
    Dim ch_asc As Integer
    Dim result As String

    For i = 1 To Len(txt)
        ' Translate the next character.
        ch = Mid$(txt, i, 1)
        ch_asc = Asc(ch)
        
        If ch_asc = vbKeySpace Then
            ' Use a plus.
            result = result & "+"
        ElseIf m_SafeChar(ch_asc) Then
            ' Use the character.
            result = result & ch
        Else
            ' Convert the character to hex.
            result = result & "%" & Right$("0" & Hex$(ch_asc), 2)
        End If
    Next

    URLEncode = result
    
End Function

' Set m_SafeChar(i) = True for characters that
' do not need protection.
Private Sub SetSafeChars()

    ' True = character don't need protection
    SetArray m_SafeChar, 46, 57, True
    SetArray m_SafeChar, 65, 90, True
    SetArray m_SafeChar, 97, 122, True
    
End Sub

Public Sub SetArray(bArray() As Boolean, startVal As Long, endVal As Long, Value As Boolean)

    Dim Tell As Long
    
    For Tell = startVal To endVal
        bArray(Tell) = Value
    Next

End Sub

