VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Private Declare Function LoadIcon Lib "user32" Alias "LoadIconA" (ByVal hInstance As Long, ByVal lpIconName As Long) As Long
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal hIcon As Long) As Long
Private Declare Function DuplicateIcon Lib "shell32.dll" (ByVal hInst As Long, ByVal hIcon As Long) As Long

Enum IDI_CONSTANTS
    IDI_APPLICATION = 32512&
    IDI_ASTERISK = 32516&
    IDI_EXCLAMATION = 32515&
    IDI_HAND = 32513&
    IDI_ERROR = IDI_HAND
    IDI_INFORMATION = IDI_ASTERISK
    IDI_QUESTION = 32514&
    IDI_WARNING = IDI_EXCLAMATION
    IDI_WINLOGO = 32517
End Enum

Dim hCurrIcon As Long

Public Property Get Handle() As Long

    Handle = hCurrIcon

End Property

Public Property Let Handle(ByVal vNewValue As Long)

    hCurrIcon = vNewValue

End Property

Public Function OpenIcon(lpIcon As IDI_CONSTANTS)

    Dim hIcon As Long

    ' Remember to clean up
    CleanUp

    ' Load the icons
    hIcon = LoadIcon(ByVal 0&, lpIcon)
    hCurrIcon = DuplicateIcon(ByVal 0&, hIcon)
    
    ' Clean up
    DestroyIcon hIcon

End Function

Public Sub PaintIcon(hdc As Long, X As Long, Y As Long)

    ' Draw the icon
    DrawIcon hdc, X, Y, hCurrIcon

End Sub

Public Sub CleanUp()

    If hCurrIcon <> 0 Then
        ' Free up all memory related to this icon
        DestroyIcon hCurrIcon
        
        ' The pointer is incorrect anyway, so set it to 0
        hCurrIcon = 0
    End If
    
End Sub

Private Sub Class_Terminate()

    ' Automatically clean up
    CleanUp

End Sub



