VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMIME"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Private Type MIME
    sName As String
    sValue As String
End Type

Private pMIME() As MIME
Private MIMECount As Long

Public Property Get ToString() As String

    Dim Tell As Long
    
    For Tell = 0 To MIMECount - 1
        ToString = ToString & pMIME(Tell).sName & ": " & pMIME(Tell).sValue & vbCrLf
    Next
    
End Property

Public Property Get MimeLowerCount() As Long

    MimeLowerCount = 0
    
End Property

Public Property Get MimeUpperCount() As Long

    MimeUpperCount = MIMECount - 1
    
End Property

Public Property Get MimeName(ByVal Index As Variant) As String

    Index = GetMIMEIndex(Index)
    
    If Index >= 0 Then
        MimeName = pMIME(Index).sName
    End If

End Property

Public Property Let MimeName(ByVal Index As Variant, ByVal vNewValue As String)

    Index = GetMIMEIndex(Index)
    
    If Index >= 0 Then
        pMIME(Index).sName = vNewValue
    End If

End Property

Public Property Get MimeValue(ByVal Index As Variant) As String

    Index = GetMIMEIndex(Index)
    
    If Index >= 0 Then
        MimeValue = pMIME(Index).sValue
    End If

End Property

Public Property Let MimeValue(ByVal Index As Variant, ByVal vNewValue As String)

    Index = GetMIMEIndex(Index)
    
    If Index >= 0 Then
        pMIME(Index).sValue = vNewValue
    End If

End Property

Public Sub Add(sName As String, sValue As String)

    ReDim Preserve pMIME(MIMECount)
    
    pMIME(MIMECount).sName = sName
    pMIME(MIMECount).sValue = sValue

    ' Increse the array-count
    MIMECount = MIMECount + 1

End Sub

Public Sub Remove(ByVal Index As Variant)

    Dim Tell As Long

    Index = GetMIMEIndex(Index)
    
    If Index >= 0 Then
    
        For Tell = Index To MIMECount - 1
            LSet pMIME(Tell) = pMIME(Tell + 1)
        Next
        
        ' Decrese the array-count
        MIMECount = MIMECount - 1
    
        ' Reallocate the array to the right size
        ReDim Preserve pMIME(MIMECount - 1)
    
    End If

End Sub

Private Function GetMIMEIndex(Index As Variant) As Long

    Dim Tell As Long
    
    If IsNumeric(Index) Then
        ' This is just a number - return it.
        GetMIMEIndex = Index
    Else
        
        ' If not, loop throughout the entire array to check and see if this is a name
        
        For Tell = 0 To MIMECount - 1
            If LCase(Index) = LCase(pMIME(Tell).sName) Then
                GetMIMEIndex = Tell
                Exit Function
            End If
        Next
    
        ' We're out of luck. Return an invalid index
        GetMIMEIndex = -1
    
    End If

End Function
