VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Private Declare Function SHCreateDirectoryEx Lib "shell32" Alias "SHCreateDirectoryExA" (ByVal hwnd As Long, ByVal pszPath As String, ByVal psa As Any) As Long

Private Type Variable
    VarName As String
    VarValue As Variant
End Type

' Public variables
Public FileName As String

' Internal variables
Private Variables() As Variable
Private VarCount As Long

Public Property Get VariableValue(ByVal Index As Variant, Optional Default As Variant) As Variant
    
    Index = FindIndex(Index)
    
    If Index >= 0 Then
        VariableValue = Variables(Index).VarValue
    Else
        If Not IsMissing(Default) Then
            VariableValue = Default
        End If
    End If
    
End Property

Public Property Let VariableValue(ByVal Index As Variant, Optional Default As Variant, ByVal vNewValue As Variant)

    Dim Tell As Long

    Tell = FindIndex(Index)
    
    If Tell >= 0 Then
        Variables(Tell).VarValue = vNewValue
    Else
        CreateVariable CStr(Index), vNewValue
    End If

End Property

Public Property Get VariableName(ByVal Index As Variant) As Variant
    
    Index = FindIndex(Index)
    
    If Index >= 0 Then
        VariableName = Variables(Index).VarName
    End If
    
End Property

Public Property Let VariableName(ByVal Index As Variant, ByVal vNewValue As Variant)

    Dim Tell As Long

    Tell = FindIndex(Index)
    
    If Tell >= 0 Then
        Variables(Tell).VarName = vNewValue
    Else
        CreateVariable CStr(Index)
    End If

End Property

Public Function FindIndex(Name As Variant) As Long

    Dim Tell As Long
    
    If IsNumeric(Name) Then
        If Name >= 0 And Name < VarCount Then
            FindIndex = Name
            Exit Function
        End If
    End If
    
    For Tell = 0 To VarCount - 1
        If Variables(Tell).VarName = Name Then
            FindIndex = Tell
            Exit Function
        End If
    Next

    ' Variable not found
    FindIndex = -1

End Function

Public Sub IncreseVariable(ByVal Index As Variant, ByVal Value As Variant)

    Index = FindIndex(Index)
    
    If Index >= 0 Then
        Variables(Index).VarValue = Variables(Index).VarValue + Value
    End If

End Sub

Public Function CreateVariable(Name As String, Optional Value As Variant) As Long

    If IsNumeric(Name) Or Name = "" Then
        CreateVariable = -1
        Exit Function
    End If

    ReDim Preserve Variables(VarCount)
    
    Variables(VarCount).VarName = Name
    Variables(VarCount).VarValue = Value
    
    ' Increse the variable holding information about how many variables there are
    VarCount = VarCount + 1

End Function

Public Sub DestroyVariable(ByVal Index As Variant)

    Dim Tell As Long

    Index = FindIndex(Index)
    
    If Index >= 0 Then
    
        ' We're supposed to remove a variable
        VarCount = VarCount - 1
    
        For Tell = Index To VarCount
            Variables(Tell).VarName = Variables(Tell + 1).VarName
            Variables(Tell).VarValue = Variables(Tell + 1).VarValue
        Next
        
        If VarCount < 0 Then
            Erase Variables
        Else
            ReDim Preserve Variables(VarCount)
        End If
        
    End If

End Sub

Public Sub SaveData(File As String)

    Dim Free As Long
    
    Free = FreeFile

    If Dir(File) <> "" Then
        Kill File
    End If
    
    ' If the directory isn't created, create it!
    SHCreateDirectoryEx 0, GetFilePath(File), ByVal 0&

    Open File For Binary As #Free
        Put #Free, , VarCount
        Put #Free, , Variables
    Close #Free
    
End Sub

Public Sub LoadData(File As String)

    Dim Free As Long
    
    If Dir(File) <> "" Then
    
        Free = FreeFile
        
        Open File For Binary As #Free
            Get #Free, , VarCount
            ReDim Variables(VarCount)
            Get #Free, , Variables
        Close #Free
    
        ' Current file
        FileName = File
    
    End If
    
End Sub


