VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Private Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean

Private Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uId As Long
    uFlags As Long
    ucallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4

Private lTray() As NOTIFYICONDATA

Public Function AddTrayIcon(ByVal hwnd As Long, ByVal Description As String, Bitmap As StdPicture) As Long

    Dim Tmp As Long
    
    Tmp = FindFree
    ReDim Preserve lTray(Tmp)
    
    lTray(Tmp).cbSize = Len(lTray(Tmp))
    lTray(Tmp).hwnd = hwnd
    lTray(Tmp).uId = Tmp + 1
    lTray(Tmp).uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
    lTray(Tmp).ucallbackMessage = WM_LBUTTONDOWN
    lTray(Tmp).hIcon = Bitmap
    lTray(Tmp).szTip = Description & Chr$(0)
    
    Shell_NotifyIcon NIM_ADD, lTray(Tmp)
    AddTrayIcon = Tmp

End Function

Public Function ChangeIcon(ByVal Index As Integer, Bitmap As StdPicture) As Long

    If Index < LBound(lTray) Or Index > UBound(lTray) Then ChangeIcon = 1
    
    lTray(Index).hIcon = Bitmap
    Shell_NotifyIcon NIM_MODIFY, lTray(Index)

End Function

Public Function ChangeDescription(ByVal Index As Integer, ByVal Description As String) As Long

    If Index < LBound(lTray) Or Index > UBound(lTray) Then ChangeDescription = 1
    
    lTray(Index).szTip = Description
    Shell_NotifyIcon NIM_MODIFY, lTray(Index)

End Function

Public Function DeleteIcon(ByVal Index As Integer) As Long

    If Index < LBound(lTray) Or Index > UBound(lTray) Then DeleteIcon = 1
    
    Shell_NotifyIcon NIM_DELETE, lTray(Index)
    lTray(Index).hwnd = 0

End Function

Public Property Get IconCount() As Long

    Dim Tell As Long
    
    For Tell = LBound(lTray) To UBound(lTray)
        If lTray(Tell).hwnd <> 0 Then
            IconCount = IconCount + 1
        End If
    Next

End Property

Private Function FindFree() As Integer

    Dim Tell As Long
    
    For Tell = LBound(lTray) To UBound(lTray)
        If lTray(Tell).hwnd = 0 Then
            FindFree = Tell
            Exit Function
        End If
    Next
    
    FindFree = UBound(lTray) + 1

End Function

Private Sub Class_Initialize()

    ' If we don't do this, then we're out of luck
    ReDim lTray(0)

End Sub

Private Sub Class_Terminate()

    Dim Tell As Long
    
    For Tell = LBound(lTray) To UBound(lTray)
        Shell_NotifyIcon NIM_DELETE, lTray(Tell)
    Next

End Sub
