Attribute VB_Name = "modMain"
Option Explicit

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

' To show/hide a window in the taskbar
Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const KEY_QUERY_VALUE = &H1
Public Const REG_SZ = 1
Public Const ERROR_SUCCESS = 0&

Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_RBUTTONUP = &H205

Public Const GWL_EXSTYLE = (-20)
Public Const WS_EX_APPWINDOW = &H40000
Public Const WS_EX_TOOLWINDOW = &H80&

Public Const SW_HIDE = 0
Public Const SW_SHOW = 5

' Classes
Public IconClass As New clsIcon
Public HTTP As New clsHTTP
Public Log As New clsLog
Public Settings As New clsSettings
Public Statistic As New clsSettings
Public Tray As New clsTray

Public Sub Main()

    ' Load settings and stat
    Settings.LoadData App.Path & "\HTTP-Settings.dat"
    Statistic.LoadData App.Path & "\HTTP-Statistic.dat"
    Log.FileName = App.Path & "\Log.dat"

    ' Show the main form
    frmMain.Show

    ' The HTTP-server isn't yet operative
    frmMain.SetStatus Server_Closed

End Sub

Public Sub TerminateApplication()

    Dim Form As Form

    ' Save all settings and stat
    Settings.SaveData App.Path & "\HTTP-Settings.dat"
    Statistic.LoadData App.Path & "\HTTP-Statistic.dat"

    ' Unload all open forms
    For Each Form In Forms
        Unload Form
    Next

End Sub

Public Sub SetShowInTaskbar(Visible As Boolean, hwnd As Long)

    Dim Ret As Long
    
    Ret = ShowWindow(hwnd, SW_HIDE): DoEvents
    
    Ret = SetWindowLong(hwnd, GWL_EXSTYLE, IIf(Visible, WS_EX_APPWINDOW, WS_EX_TOOLWINDOW))
    DoEvents
    
    Ret = ShowWindow(hwnd, SW_SHOW)

End Sub

Public Function GetExtention(File As String) As String

    GetExtention = Right(File, Len(File) - InStrRev(File, "."))

End Function

Public Function GetFileName(File As String) As String

    GetFileName = Right(File, Len(File) - InStrRev(File, "\"))

End Function

Public Function GetFilePath(File As String) As String

    GetFilePath = Left(File, InStrRev(File, "\"))

End Function

Public Function CutTo(sText As String, sChar As String, Optional Start As Long = -1, Optional LessLenght As Long) As String

    CutTo = Left(sText, InStrRev(sText, sChar, Start) - LessLenght)

End Function

Public Function StripNulls(OriginalStr As String) As String

    If (InStr(OriginalStr, Chr(0)) > 0) Then
        OriginalStr = Left(OriginalStr, InStr(OriginalStr, Chr(0)) - 1)
    End If
    
    StripNulls = OriginalStr
    
End Function

Public Function LimitSize(sText As String, lLenght As Long) As String
    
    If Len(sText) > lLenght Then
        LimitSize = Mid(sText, 1, lLenght - 3) & "..."
    Else
        LimitSize = sText
    End If

End Function
